import 'package:json_schema/json_schema.dart';

main() {
  var schema = JsonSchema.create({
    "\$schema": "https://json-schema.org/draft/2020-12/schema",
    "anyOf": [
        {
          "properties": {
            "type": {
              "type": "string",
            }
          },
          "required": ["type"],
        },
        {
          "type": "object",
          "properties": {
            "scope": {
              "type":"string"
            },
            "options": {
              "type": "object",
              "properties": {
                "test": {
                  "type": "string",
                },
              },
            },
            "type": {
              "type": "null"
            }
          },
          "required": ["scope"],
          "additionalProperties": false
        }
      ]
  });

  final validation = schema.validate({
    "scope": "#/properties/test",
    "options": {
      "test": "test"
    }
  });

  print(validation.errors);
  print(validation.isValid);
}